<template>
  <v-list two-line>
    <v-list-tile 
      v-if="back"
      avatar
      @click.prevent="goBackToParent">
      <v-list-tile-avatar>
        <v-icon x-large>keyboard_return</v-icon>
      </v-list-tile-avatar>
      <v-list-tile-content>
        <v-list-tile-title>
          Go Back
        </v-list-tile-title>

      </v-list-tile-content>
    </v-list-tile>


    <template v-for="(item, index) in items">
      <v-list-tile 
        :key="index"
        avatar
        @click.prevent="clickOnItem(item)"
        @dblclick.native="dblclickOnItem(item)"
      >
        <v-list-tile-avatar>
          <v-icon 
            v-if="isSelected(item)" 
            x-large 
            color="success">check_circle</v-icon>
          <v-icon 
            v-else 
            x-large>{{ itemIcon(item) }}</v-icon>
        </v-list-tile-avatar>

        <v-list-tile-content>
          <v-list-tile-title v-html="itemName(item)"/>

          <v-list-tile-sub-title>
            {{ item.created_at }}
          </v-list-tile-sub-title>

        </v-list-tile-content>

        <v-list-tile-action v-if="showDownload">
          <v-tooltip left>
            <v-btn 
              slot="activator" 
              icon 
              ripple
              @click.prevent="downloadItem(item)"
            >
              <v-icon color="primary">get_app</v-icon>
            </v-btn>
            <span>Download</span>
          </v-tooltip>
        </v-list-tile-action>

        <v-list-tile-action v-if="showDelete">
          <v-tooltip left>
            <v-btn 
              slot="activator" 
              icon 
              ripple
              @click.prevent="deleteItem(item)"
            >
              <v-icon color="red lighten-1">delete</v-icon>
            </v-btn>
            <span>Delete</span>
          </v-tooltip>
        </v-list-tile-action>

      </v-list-tile>

      <v-divider 
        v-if="index + 1 < items.length" 
        :key="`divider-${index}`"/>
      
    </template>
  </v-list>
</template>

<script>

import {bus} from '@js/bus'

export default {
	
	props:{
		// section:custom_props
		items: {
			type: Array,
			default: () => {
				return []
			}
		},
		storage: {
			type: String,
			default: 'local'
		},
		selectFile: {
			type: Boolean,
			default: false
		},
		selectDirectory: {
			type: Boolean,
			default: false
		},
		multiSelect: {
			type: Boolean,
			default: false
		},
		back: {
			type: Boolean,
			default: false
		}
		// endsection:custom_props
	},

	data() {
		return {
			selected: []
		}
	},

	computed: {
		showActions() {
			return !this.selectFile && !this.selectDirectory
		},

		showDelete() {
			return this.showActions
		},

		showDownload() {
			return this.showActions
		}
	},

	methods: {
		itemIcon(item) {
			if(item.is_directory == '1')
				return 'folder'
			return 'description'
		},

		itemLink(item) {
			if(item.is_directory == '1') {
				//return 'files/' + item.id
				return { name: 'storage', params: {storageType: this.storage, fileId: item.id} }
			} else {
				return 'files/' + item.id + '/view'
			}
		},

		itemName(item) {
			return item.name + item.ext
		},

		isSelected(item) {
			return this.selected.includes(item.id)
		},

		deleteItem(item) {
			this.$emit('delete', item)
		},

		downloadItem(item) {
			this.$emit('download', item)
		},

		addToSelection(item) {
			if(!this.multiSelect) {
				this.selected = []
			}
			this.selected.push(item.id)
			this.notifySelectionChange()
		},

		removeFromSelectin(item) {
			this.notifySelectionChange()
		},

		notifySelectionChange() {
			var result = []
			this.items.forEach( function(el) {
				if(this.selected.includes(el.id))
					result.push(el)
			}, this)
			this.$emit('selection-change', result)
		},

		clearSelection(item) {
			this.selected = []
			this.notifySelectionChange()
		},

		clickOnItem(item) {
			if(item.is_directory == '1') {
				if(!this.selectDirectory) {
					this.clearSelection()
					this.$emit('go-to', item)
				}
			} else {
				this.addToSelection(item)
			}
		},

		dblclickOnItem(item) {
			console.log('dblclick', item)
			if(item.is_directory == '1') {
				if(this.selectDirectory) {
					this.clearSelection()
					this.$emit('go-to', item)
				}
			} else {

			}
		},

		goBackToParent() {
			this.clearSelection()
			this.$emit('go-back')
		}
	},

}

</script>

<style type="text/css">
	
</style>